#include "nodes/base/base.hpp"
#include "nodes/stream/streamNode.hpp"
#include "nodes/infer/inferNode.hpp"
#include "nodes/draw/drawNode.hpp"


int main()
{
    std::shared_ptr<Node::StreamNode> src_node   = std::make_shared<Node::StreamNode>("src", "rtsp://admin:lww123456@172.16.22.16:554/Streaming/Channels/101");
    src_node->set_skip_frame(10);


    std::shared_ptr<Node::InferNode> infer_node = std::make_shared<Node::InferNode>("infer1");
    std::shared_ptr<Node::DrawNode> draw_node = std::make_shared<Node::DrawNode>("infer2");
    Node::LinkNode(src_node, infer_node);
    Node::LinkNode(infer_node, draw_node);
    draw_node->start();
    infer_node->start();
    src_node->start();
    
    while(true)
    {
        std::this_thread::sleep_for(std::chrono::seconds(1));
    }
    return 0;
}

// TODO: 单模型多路复用