#include "nodes/base/base.hpp"
#include "nodes/infer/inferNode.hpp"
#include <unordered_map>

namespace Node
{

void InferNode::work()
{
    printf("InferNode %s\n", name_.c_str());
    while (running_)
    {
        
        for (auto& input_buffer : input_buffers_)
        {
            std::shared_ptr<meta::MetaData> metaData;
            if (!input_buffer.second->try_pop(metaData))
            {
                continue;
            }
            printf("Node %s get data from %s\n", name_.c_str(), input_buffer.first.c_str());
            // do something
            // cv::Mat image = metaData->image;

            // cv::imwrite("test.jpg", image);
            metaData->boxes.push_back(meta::Box(0, 0, 100, 100, 0.9, "test"));
            metaData->boxes.push_back(meta::Box(0, 0, 100, 100, 0.9, "test"));
            for (auto& output_buffer : output_buffers_)
            {
                printf("Node %s push data to %s\n", name_.c_str(), output_buffer.first.c_str());
                output_buffer.second->push(metaData);
            }
        }
    }
};

}   // namespace Node